Subject: [PATCH 3/5] arm64, pci: Allow RC drivers to supply pcibios_add_device() implementation.

From: [email-masked] (David Daney)
Date: Fri, 17 Jul 2015 09:38:45 -0700

On 07/17/2015 04:00 AM, Lorenzo Pieralisi wrote:
> Hi David,
>
> On Thu, Jul 16, 2015 at 06:00:36PM +0100, David Daney wrote:
>> On 07/16/2015 02:04 AM, Lorenzo Pieralisi wrote:
>>> Hi David,
>>>
>>> On Wed, Jul 15, 2015 at 05:54:43PM +0100, David Daney wrote:
>>>> From: David Daney <[email-masked]>
>>>>
>> [...]
>>>> diff --git a/arch/arm64/kernel/pci.c b/arch/arm64/kernel/pci.c
>>>> index 4095379..3356023 100644
>>>> --- a/arch/arm64/kernel/pci.c
>>>> +++ b/arch/arm64/kernel/pci.c
>>>> @@ -38,11 +38,21 @@ resource_size_t pcibios_align_resource(void *data, const struct resource *res,
>>>>    	return res->start;
>>>>    }
>>>>
>>>> +static int (*pcibios_add_device_impl)(struct pci_dev *);
>>>> +
>>>> +void set_pcibios_add_device(int (*arg)(struct pci_dev *))
>>>> +{
>>>> +	pcibios_add_device_impl = arg;
>>>> +}
>>>> +
>>>>    /*
>>>>     * Try to assign the IRQ number from DT when adding a new device
>>>>     */
>>>>    int pcibios_add_device(struct pci_dev *dev)
>>>>    {
>>>> +	if (pcibios_add_device_impl)
>>>> +		return pcibios_add_device_impl(dev);
>>>
>>> I am totally against this (and to be honest by reading the other
>>> patches I failed to understand why you even need it), see above.
>>>
>>
>> It is because ...
>>
>>
>>> Thanks,
>>> Lorenzo
>>>
>>>> +
>>>>    	dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
>>
>>
>>    ... this is total crap.  But I didn't want to break existing systems.
>
> That's a good aim, but you are still failing to explain the issue properly
> I am afraid.
>
>> The PCI RC drivers need a way to configure the legacy virtual-wire
>> interrupts, because the existing code doesn't do it.
>
> Can I ask you please to explain the issue a bit more clearly (and why
> the OF API does not work for you ?)

Several problems:

1) It prints many times to the boot log this string:
     pci 0000:01:0e.2: of_irq_parse_pci() failed with rc=-19

2) For a RC with no device_node it does nothing (in addition to printing 
the annoying message).

> Thank you !
> Lorenzo